diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/ali5455/ali5455.c oss-v4.1test0-070624-src-gpl/kernel/drv/ali5455/ali5455.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/ali5455/ali5455.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/ali5455/ali5455.c	Tue Jun 26 22:19:34 2007
@@ -380,7 +380,7 @@
 static int
 ALI_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void ALI_audio_trigger (int dev, int state);
@@ -416,7 +416,7 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   if (portc->port_type == DF_SPDIF)
@@ -426,7 +426,7 @@
 	  cmn_err (CE_WARN,
 		   "ICH: The S/PDIF device supports only playback\n");
 	  MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-	  return -EIO;
+	  return RETERR(EIO);
 	}
     }
   else
@@ -434,7 +434,7 @@
       if (devc->open_mode & mode)
 	{
 	  MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-	  return -EBUSY;
+	  return RETERR(EBUSY);
 	}
 
       devc->open_mode |= mode;
@@ -704,14 +704,14 @@
 ALI_check_input (int dev)
 {
   cmn_err (CE_WARN, "OSS ALI: Input timed out.\n");
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
 ALI_check_output (int dev)
 {
   cmn_err (CE_WARN, "OSS ALI: Output timed out\n");
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static const audiodrv_t ALI_audio_driver = {
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/allegro/allegro.c oss-v4.1test0-070624-src-gpl/kernel/drv/allegro/allegro.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/allegro/allegro.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/allegro/allegro.c	Tue Jun 26 22:19:35 2007
@@ -367,7 +367,7 @@
 static int
 allegro_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void allegro_audio_trigger (int dev, int state);
@@ -403,13 +403,13 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   if (devc->open_mode & mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   devc->open_mode |= mode;
@@ -690,7 +690,7 @@
 	}
 
       if (!db->rawbuf)
-	return -ENOMEM;
+	return RETERR(ENOMEM);
 
 #ifdef linux
       /* now mark the pages as reserved; otherwise remap_page_range doesn't do what we want */
@@ -726,7 +726,7 @@
       db->rawbuf = NULL;
       return 0;
     }
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static audiodrv_t allegro_audio_driver = {
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/als300/als300.c oss-v4.1test0-070624-src-gpl/kernel/drv/als300/als300.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/als300/als300.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/als300/als300.c	Tue Jun 26 22:19:35 2007
@@ -286,7 +286,7 @@
 static int
 als300_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void als300_audio_trigger (int dev, int state);
@@ -322,13 +322,13 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   if (devc->open_mode & mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   devc->open_mode |= mode;
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/als4000/als4000.c oss-v4.1test0-070624-src-gpl/kernel/drv/als4000/als4000.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/als4000/als4000.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/als4000/als4000.c	Tue Jun 26 22:19:35 2007
@@ -255,17 +255,17 @@
     right = 100;
 
   if (dev > 31)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   if (!(ALS4000_MIXER_DEVICES & (1 << dev)))	/*
 						 * Not supported
 						 */
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   regoffs = als4000_mix[dev][LEFT_CHN].regno;
 
   if (regoffs == 0)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   val = als4000_getmixer (devc, regoffs);
   change_bits (devc, &val, dev, LEFT_CHN, left);
@@ -351,7 +351,7 @@
 	  }
     }
   else
-    return -EINVAL;
+    return RETERR(EINVAL);
 }
 
 
@@ -550,7 +550,7 @@
 static int
 als4000_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
@@ -609,13 +609,13 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   if (devc->open_mode & mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   devc->open_mode |= mode;
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/apci97/apci97.c oss-v4.1test0-070624-src-gpl/kernel/drv/apci97/apci97.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/apci97/apci97.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/apci97/apci97.c	Tue Jun 26 22:19:35 2007
@@ -541,7 +541,7 @@
 static int
 apci97_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void apci97_audio_trigger (int dev, int state);
@@ -577,7 +577,7 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
   portc->open_mode = mode;
   portc->audio_enabled = ~mode;
@@ -962,7 +962,7 @@
 
   if (devc->midi_opened)
     {
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   devc->midi_input_intr = inputbyte;
@@ -1013,7 +1013,7 @@
 static int
 apci97_midi_ioctl (int dev, unsigned cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static midi_driver_t apci97_midi_driver = {
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/atiaudio/atiaudio.c oss-v4.1test0-070624-src-gpl/kernel/drv/atiaudio/atiaudio.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/atiaudio/atiaudio.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/atiaudio/atiaudio.c	Tue Jun 26 22:19:35 2007
@@ -98,7 +98,7 @@
       if (!timeout--)
 	{
 	  cmn_err (CE_WARN, "ATIIXP: codec ready timed out\n");
-	  return -EIO;
+	  return RETERR(EIO);
 	}
       oss_udelay (10);
     }
@@ -121,7 +121,7 @@
     {
       cmn_err (CE_WARN, "ATI: ac97 not ready\n");
       MUTEX_EXIT_IRQRESTORE (devc->low_mutex, flags);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   addr = (unsigned int) (reg << 9) | (1 << 8) | (1 << 2);
@@ -131,7 +131,7 @@
     {
       cmn_err (CE_WARN, "ATI: ac97 not ready\n");
       MUTEX_EXIT_IRQRESTORE (devc->low_mutex, flags);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   timeout = 1000;
@@ -374,7 +374,7 @@
 static int
 ATI_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void ATI_audio_trigger (int dev, int state);
@@ -410,7 +410,7 @@
   if (portc->open_mode || (devc->open_mode & mode))
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   portc->open_mode = mode;
@@ -612,7 +612,7 @@
   if (n > BDL_SIZE)
     {
       cmn_err (CE_WARN, "oss: Internal error - BDL too small\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   for (i = 0; i < n; i++)
@@ -708,7 +708,7 @@
       if (n > BDL_SIZE)
 	{
 	  cmn_err (CE_WARN, "oss: Internal error - BDL too small\n");
-	  return -EIO;
+	  return RETERR(EIO);
 	}
 
       for (i = 0; i < n; i++)
@@ -734,14 +734,14 @@
 ATI_check_input (int dev)
 {
   cmn_err (CE_WARN, "OSS ATI: Input timed out.\n");
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
 ATI_check_output (int dev)
 {
   cmn_err (CE_WARN, "OSS ATI: Output timed out\n");
-  return -EIO;
+  return RETERR(EIO);
 }
 
 
@@ -1024,7 +1024,11 @@
   devc->membar_virt =
     (char *) MAP_PCI_MEM (devc->osdev, 0, devc->membar_addr, 256);
 
-
+  if (devc->membar_virt == NULL)
+    {
+      cmn_err (CE_WARN, "ATIIXP: Cannot map pci mem\n");
+      return 0;
+    }
 
   pci_command |= PCI_COMMAND_MASTER | PCI_COMMAND_MEMORY;
   pci_write_config_word (osdev, PCI_COMMAND, pci_command);
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/audigyls/audigyls.c oss-v4.1test0-070624-src-gpl/kernel/drv/audigyls/audigyls.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/audigyls/audigyls.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/audigyls/audigyls.c	Tue Jun 26 22:19:36 2007
@@ -240,7 +240,7 @@
   if (i == 10000)
     {
       MUTEX_EXIT_IRQRESTORE (devc->low_mutex, flags);
-      return -EIO;
+      return RETERR(EIO);
     }
   dtemp = INW (devc->osdev, devc->base + 0x1c);
   MUTEX_EXIT_IRQRESTORE (devc->low_mutex, flags);
@@ -263,7 +263,7 @@
   if (i == 10000)
     {
       MUTEX_EXIT_IRQRESTORE (devc->low_mutex, flags);
-      return -EIO;
+      return RETERR(EIO);
     }
   OUTW (devc->osdev, wData, devc->base + 0x1c);
   MUTEX_EXIT_IRQRESTORE (devc->low_mutex, flags);
@@ -441,7 +441,7 @@
 static int
 audigyls_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void audigyls_trigger (int dev, int state);
@@ -463,13 +463,13 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   if (devc->open_mode & mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   devc->open_mode |= mode;
@@ -1001,7 +1001,7 @@
 
   if (devc->midi_opened)
     {
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   while (input_avail (devc))
@@ -1069,7 +1069,7 @@
 static int
 audigylsuart_ioctl (int dev, unsigned cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static midi_driver_t audigyls_midi_driver = {
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/audioloop/audioloop.c oss-v4.1test0-070624-src-gpl/kernel/drv/audioloop/audioloop.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/audioloop/audioloop.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/audioloop/audioloop.c	Tue Jun 26 22:19:36 2007
@@ -174,7 +174,7 @@
   audioloop_portc_t *portc = audio_engines[dev]->portc;
   if (!portc->peer->output_triggered)
     {
-      return -ECONNRESET;
+      return RETERR(ECONNRESET);
     }
   return 0;
 }
@@ -186,11 +186,11 @@
 
   if (!portc->peer->input_triggered)
     {
-      return -ECONNRESET;
+      return RETERR(ECONNRESET);
     }
 
   if (portc->peer->open_mode == 0)
-    return -EIO;
+    return RETERR(EIO);
   return 0;
 }
 
@@ -347,17 +347,17 @@
   adev_t *adev;
 
   if ((mode & OPEN_READ) && (mode & OPEN_WRITE))
-    return -EACCES;
+    return RETERR(EACCES);
 
   if (portc == NULL || portc->peer == NULL)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   MUTEX_ENTER_IRQDISABLE (devc->mutex, flags);
 
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   portc->open_mode = mode;
@@ -387,14 +387,14 @@
   oss_native_word flags;
 
   if (portc == NULL || portc->peer == NULL)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   MUTEX_ENTER_IRQDISABLE (devc->mutex, flags);
 
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   portc->open_mode = mode;
@@ -443,7 +443,7 @@
 static int
 audioloop_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void
@@ -526,7 +526,7 @@
       if (status & WK_SIGNAL)
 	{
 	  MUTEX_EXIT_IRQRESTORE (portc->mutex, flags);
-	  return -EINTR;
+	  return RETERR(EINTR);
 	}
     }
   MUTEX_EXIT_IRQRESTORE (portc->mutex, flags);
@@ -558,7 +558,7 @@
       if (status & WK_SIGNAL)
 	{
 	  MUTEX_EXIT_IRQRESTORE (portc->mutex, flags);
-	  return -EINTR;
+	  return RETERR(EINTR);
 	}
     }
   MUTEX_EXIT_IRQRESTORE (portc->mutex, flags);
@@ -623,7 +623,7 @@
   dmap->dmabuf_phys = 0;	/* Not mmap() capable */
   dmap->dmabuf = KERNEL_MALLOC (MY_BUFFSIZE);
   if (dmap->dmabuf == NULL)
-    return -ENOSPC;
+    return RETERR(ENOSPC);
   dmap->buffsize = MY_BUFFSIZE;
 
   return 0;
@@ -716,7 +716,7 @@
     ADEV_FIXEDRATE | ADEV_SPECIAL;
 
   if ((portc = PMALLOC (devc->osdev, sizeof (*portc))) == NULL)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
   memset (portc, 0, sizeof (*portc));
 
   portc->devc = devc;
@@ -724,7 +724,7 @@
   if ((portc->wq = oss_create_wait_queue (devc->osdev, "audioloop")) == NULL)
     {
       cmn_err (CE_WARN, "Cannot create audioloop wait queue\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   portc->instance = num;
@@ -777,14 +777,14 @@
     ADEV_FIXEDRATE | ADEV_SPECIAL | ADEV_LOOP;
 
   if ((portc = PMALLOC (devc->osdev, sizeof (*portc))) == NULL)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
   memset (portc, 0, sizeof (*portc));
 
   portc->devc = devc;
   if ((portc->wq = oss_create_wait_queue (devc->osdev, "audioloop")) == NULL)
     {
       cmn_err (CE_WARN, "Cannot create audioloop wait queue\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   portc->instance = num;
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/audiopci/audiopci.c oss-v4.1test0-070624-src-gpl/kernel/drv/audiopci/audiopci.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/audiopci/audiopci.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/audiopci/audiopci.c	Tue Jun 26 22:19:36 2007
@@ -230,7 +230,7 @@
 apci_mixer_get (apci_devc * devc, int dev)
 {
   if (!((1 << dev) & MIXER_DEVS))
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   return devc->levels[dev];
 }
@@ -246,10 +246,10 @@
   unsigned char val;
 
   if (dev > 31)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   if (!(MIXER_DEVS & (1 << dev)))
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   if (left > 100)
     left = 100;
@@ -272,7 +272,7 @@
 #endif
 
   if (ak_mix_devices[dev][LEFT_CHN].regno == 0xff)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   devc->levels[dev] = retvol;
 
@@ -365,7 +365,7 @@
 	  }
     }
   else
-    return -EINVAL;
+    return RETERR(EINVAL);
 }
 
 static int
@@ -460,7 +460,7 @@
 	  break;
 
 	default:
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	}
 
       return value;
@@ -530,13 +530,13 @@
 	  break;
 
 	default:
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	}
 
       return value;
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
@@ -800,7 +800,7 @@
 static int
 apci_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void apci_audio_trigger (int dev, int state);
@@ -836,7 +836,7 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   portc->open_mode = mode;
@@ -1216,7 +1216,7 @@
 
   if (devc->midi_opened)
     {
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   devc->midi_input_intr = inputbyte;
@@ -1272,7 +1272,7 @@
 static int
 apci_midi_ioctl (int dev, unsigned cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static midi_driver_t apci_midi_driver = {
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/cmi8788/cmi8788.c oss-v4.1test0-070624-src-gpl/kernel/drv/cmi8788/cmi8788.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/cmi8788/cmi8788.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/cmi8788/cmi8788.c	Tue Jun 26 22:19:36 2007
@@ -291,7 +291,7 @@
   if (status & 0x1)
     {
       cmn_err (CE_WARN, "Two-Wire interface busy\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   /* first write the Register Address into the MAP register */
@@ -452,7 +452,7 @@
 static int
 cmi8788_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 
@@ -489,13 +489,13 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   if (devc->open_mode & mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   devc->open_mode |= mode;
@@ -1066,14 +1066,14 @@
 cmi8788_check_input (int dev)
 {
   cmn_err (CE_WARN, "Input timed out on %s.\n", audio_engines[dev]->devnode);
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
 cmi8788_check_output (int dev)
 {
   cmn_err (CE_WARN, "Output timed out on %s.\n", audio_engines[dev]->devnode);
-  return -EIO;
+  return RETERR(EIO);
 }
 
 
@@ -1217,7 +1217,7 @@
 
   if (devc->midi_opened)
     {
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   while (input_avail (devc))
@@ -1285,7 +1285,7 @@
 static int
 cmi8788uart_ioctl (int dev, unsigned cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static midi_driver_t cmi8788_midi_driver = {
@@ -1544,7 +1544,7 @@
 	  break;
 
 	default:
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	}
 
       return value;
@@ -1602,11 +1602,11 @@
 	  break;
 
 	default:
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	}
       return (value);
     }
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 
@@ -1817,7 +1817,7 @@
       return (value);
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/cmpci/cmpci.c oss-v4.1test0-070624-src-gpl/kernel/drv/cmpci/cmpci.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/cmpci/cmpci.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/cmpci/cmpci.c	Tue Jun 26 22:19:37 2007
@@ -414,17 +414,17 @@
     right = 100;
 
   if (chan > 31)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   if (!(CMEDIA_MIXER_DEVICES & (1 << chan)))	/*
 						 * Not supported
 						 */
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   regoffs = cmpci_mix[chan][LEFT_CHN].regno;
 
   if (regoffs == 0)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   val = cmpci_getmixer (devc, regoffs);
   change_bits (devc, &val, chan, LEFT_CHN, left);
@@ -524,7 +524,7 @@
 	  }
     }
   else
-    return -EINVAL;
+    return RETERR(EINVAL);
 }
 
 static int
@@ -653,7 +653,7 @@
 	  break;
 
 	default:
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	}
 
       return value;
@@ -925,12 +925,12 @@
 	  break;
 
 	default:
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	}
 
       return (value);
     }
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
@@ -1220,7 +1220,7 @@
 static int
 cmpci_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 
@@ -1257,7 +1257,7 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   if (!(devc->dev_mode & DUALDAC_MODE))
@@ -1265,7 +1265,7 @@
       if (devc->open_mode & mode)
 	{
 	  MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-	  return -EBUSY;
+	  return RETERR(EBUSY);
 	}
 
       devc->open_mode |= mode;
@@ -1753,7 +1753,7 @@
     case DUALDAC_MODE:
       cmn_err (CE_WARN, "CMPCI: Cannot record because DUALDAC mode is ON.\n");
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EIO;
+      return RETERR(EIO);
 
     case SPDIFIN_MODE:
       if (portc->speed < 44100)
@@ -1761,7 +1761,7 @@
 	  cmn_err (CE_WARN,
 		   "CMPCI: Cannot record spdif at sampling rate less than 44.1Khz.\n");
 	  MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-	  return -EIO;
+	  return RETERR(EIO);
 	}
       set_adc_rate (dev, CHAN1);
       set_adc_fmt (dev, CHAN1);
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/cs4280/cs4280.c oss-v4.1test0-070624-src-gpl/kernel/drv/cs4280/cs4280.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/cs4280/cs4280.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/cs4280/cs4280.c	Tue Jun 26 22:19:37 2007
@@ -699,7 +699,7 @@
 static int
 cs4280_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void cs4280_audio_trigger (int dev, int state);
@@ -736,13 +736,13 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   if (devc->open_mode & mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   devc->open_mode |= mode;
@@ -1293,7 +1293,7 @@
 
   if (devc->midi_opened)
     {
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
   MUTEX_ENTER_IRQDISABLE (devc->mutex, flags);
   devc->midi_input_intr = inputbyte;
@@ -1359,7 +1359,7 @@
 static int
 cs4280_midi_ioctl (int dev, unsigned cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static midi_driver_t cs4280_midi_driver = {
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/cs4281/cs4281.c oss-v4.1test0-070624-src-gpl/kernel/drv/cs4281/cs4281.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/cs4281/cs4281.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/cs4281/cs4281.c	Tue Jun 26 22:19:37 2007
@@ -327,7 +327,7 @@
 static int
 cs4281_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void cs4281_audio_trigger (int dev, int state);
@@ -361,13 +361,13 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   if (devc->open_mode & mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   devc->open_mode |= mode;
@@ -633,7 +633,7 @@
   cs4281_devc *devc = (cs4281_devc *) midi_devs[dev]->devc;
   if (devc->midi_opened)
     {
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   devc->midi_input_intr = inputbyte;
@@ -682,7 +682,7 @@
 static int
 cs4281_midi_ioctl (int dev, unsigned cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static midi_driver_t cs4281_midi_driver = {
@@ -715,14 +715,14 @@
 	  if (tmp1 != 0x4281)
 	    {
 	      cmn_err (CE_WARN, "Resetting AC97 failed\n");
-	      return -EIO;
+	      return RETERR(EIO);
 	    }
 	  WRITEL (BA0_CFLR, 0x1);
 	  tmp1 = READL (BA0_CFLR);
 	  if (tmp1 != 0x1)
 	    {
 	      cmn_err (CE_WARN, "Resetting AC97 still fails\n");
-	      return -EIO;
+	      return RETERR(EIO);
 	    }
 	}
     }
@@ -740,7 +740,7 @@
   if ((tmp1 = READL (BA0_SERC1)) != (SERC1_SO1EN | SERC1_SO1F_AC97))
     {
       cmn_err (CE_WARN, "CS4281: SERC1: AC97 check failed\n");
-      return -EIO;
+      return RETERR(EIO);
     }
   /* setup power management to full power */
   WRITEL (BA0_SSPM, 0x7E);
@@ -777,7 +777,7 @@
   if (!(READL (BA0_CLKCR1) & CLKCR1_DLLRDY))
     {
       cmn_err (CE_WARN, "CS4281: DLLRDY Clock not ready\n");
-      return -EIO;
+      return RETERR(EIO);
     }
   /* (6) Enable ASYNC generation. */
   WRITEL (BA0_ACCTL, ACCTL_ESYN);	/* (460h) */
@@ -796,7 +796,7 @@
   if (!(READL (BA0_ACSTS) & ACSTS_CRDY))	/* If never came ready, */
     {
       cmn_err (CE_WARN, "CS4281: AC97 not ready\n");
-      return -EIO;		/*   exit initialization. */
+      return RETERR(EIO);		/*   exit initialization. */
     }
   /* (8) Assert the 'valid frame' signal so we can */
   /* begin sending commands to the AC97 codec. */
@@ -818,7 +818,7 @@
       (ACISV_ISV3 | ACISV_ISV4))
     {
       cmn_err (CE_WARN, "CS4281: AC97 Slot not valid\n");
-      return -EIO;		/* If no valid data, exit initialization. */
+      return RETERR(EIO);		/* If no valid data, exit initialization. */
     }
   /* (12) Start digital data transfer of audio data to the codec. */
   WRITEL (BA0_ACOSV, ACOSV_SLV3 | ACOSV_SLV4);	/* (468h) */
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/digi32/digi32.c oss-v4.1test0-070624-src-gpl/kernel/drv/digi32/digi32.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/digi32/digi32.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/digi32/digi32.c	Tue Jun 26 22:19:37 2007
@@ -294,7 +294,7 @@
 static int
 digi32_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void digi32_trigger (int dev, int state);
@@ -334,7 +334,7 @@
   if (portc->open_mode != 0)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   portc->open_mode = mode;
@@ -493,7 +493,7 @@
   if (bsize != 8 * 1024)
     {
       cmn_err (CE_CONT, "Illegal fragment size %d\n", bsize);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   prev_dblbit = cmd & C_DS;
@@ -550,7 +550,7 @@
   if (i >= 1000)
     {
       cmn_err (CE_WARN, "Digi32: No input signal detected\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   devc->speed_locked = 1;
@@ -566,7 +566,7 @@
   if (bsize != 8 * 1024)
     {
       cmn_err (CE_CONT, "Illegal fragment size %d\n", bsize);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   prev_dblbit = cmd & C_DS;
@@ -610,7 +610,7 @@
   dmap->dmabuf_phys = 0;	/* Not mmap() capable */
   dmap->dmabuf = KERNEL_MALLOC (digi32_buffsize);
   if (dmap->dmabuf == NULL)
-    return -ENOSPC;
+    return RETERR(ENOSPC);
   dmap->buffsize = digi32_buffsize;
 
   return 0;
@@ -733,7 +733,7 @@
     return *arg = 100 | (100 << 8);
   if (cmd == SOUND_MIXER_WRITE_VOLUME || cmd == SOUND_MIXER_WRITE_PCM)
     return *arg = 100 | (100 << 8);
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static mixer_driver_t digi32_mixer_driver = {
@@ -748,7 +748,7 @@
   unsigned int data;
 
   if (ctrl < 0)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   offs = (ctrl >> 4) & 0x0f;	/* # of bits in the field */
   nbits = ctrl & 0x0f;		/* Shift amount */
@@ -762,14 +762,14 @@
   if (cmd == SNDCTL_MIX_WRITE)
     {
       if (value < 0 || value >= (1 << nbits))
-	return -EINVAL;
+	return RETERR(EINVAL);
       data = devc->cmd & ~(((1 << nbits) - 1) << offs);
       data |= (value & ((1 << nbits) - 1)) << offs;
       devc->cmd = data;
       return value;
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/digi96/digi96.c oss-v4.1test0-070624-src-gpl/kernel/drv/digi96/digi96.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/digi96/digi96.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/digi96/digi96.c	Tue Jun 26 22:19:37 2007
@@ -265,7 +265,7 @@
 static int
 digi96_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void digi96_trigger (int dev, int state);
@@ -371,7 +371,7 @@
   if (portc->open_mode != 0 || (devc->open_mode & mode))	/* Busy? */
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   portc->open_mode = mode;
@@ -496,7 +496,7 @@
   if (!devc->master)
     {
       if (!verify_input (devc, portc))
-	return -EIO;
+	return RETERR(EIO);
     }
 
   cmd = devc->ctrl1_bits;
@@ -551,7 +551,7 @@
   write_ctrl1 (devc, cmd);
 
   if (!verify_input (devc, portc))
-    return -EIO;
+    return RETERR(EIO);
   PCI_WRITEL (devc->osdev, devc->pRESETREC, 0);
 
   return 0;
@@ -645,7 +645,7 @@
     return *arg = 100 | (100 << 8);
   if (cmd == SOUND_MIXER_WRITE_VOLUME || cmd == SOUND_MIXER_WRITE_PCM)
     return *arg = 100 | (100 << 8);
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static mixer_driver_t digi96_mixer_driver = {
@@ -659,7 +659,7 @@
   unsigned int tmp;
 
   if (ctrl < 0)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   if (cmd == SNDCTL_MIX_READ)
     {
@@ -698,7 +698,7 @@
 	  break;
 	}
 
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   if (cmd == SNDCTL_MIX_WRITE)
@@ -712,7 +712,7 @@
 
 	case 2:
 	  if (value < 0 || value > 3)
-	    return -EINVAL;
+	    return RETERR(EINVAL);
 
 	  devc->input_source = value;
 	  return value;
@@ -733,7 +733,7 @@
 
 	case 4:
 	  if (value > 2 || (!devc->have_adat && value > 1))
-	    return -EINVAL;
+	    return RETERR(EINVAL);
 
 	  devc->mode = value;
 	  return value;
@@ -783,10 +783,10 @@
 
 	}
 
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/emu10k1x/emu10k1x.c oss-v4.1test0-070624-src-gpl/kernel/drv/emu10k1x/emu10k1x.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/emu10k1x/emu10k1x.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/emu10k1x/emu10k1x.c	Tue Jun 26 22:19:38 2007
@@ -308,7 +308,7 @@
 static int
 emu10k1x_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void emu10k1x_trigger (int dev, int state);
@@ -345,7 +345,7 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   portc->open_mode = mode;
@@ -572,7 +572,7 @@
 	  portc->recbuf =
 	    CONTIG_MALLOC (devc->osdev, BUFSIZE, MEMLIMIT_32BITS, &phaddr);
 	  if (portc->recbuf == NULL)
-	    return -ENOMEM;
+	    return RETERR(ENOMEM);
 	  portc->recbuf_phys = phaddr;
 	}
     }
@@ -581,7 +581,7 @@
       portc->playbuf =
 	CONTIG_MALLOC (devc->osdev, BUFSIZE, MEMLIMIT_32BITS, &phaddr);
       if (portc->playbuf == NULL)
-	return -ENOMEM;
+	return RETERR(ENOMEM);
       portc->playbuf_phys = phaddr;
     }
   return 0;
@@ -729,7 +729,7 @@
 
   if (devc->midi_opened)
     {
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   while (input_avail (devc))
@@ -797,7 +797,7 @@
 static int
 emu10k1xuart_ioctl (int dev, unsigned cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static midi_driver_t emu10k1x_midi_driver = {
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/fm801/fm801.c oss-v4.1test0-070624-src-gpl/kernel/drv/fm801/fm801.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/fm801/fm801.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/fm801/fm801.c	Tue Jun 26 22:19:38 2007
@@ -446,7 +446,7 @@
 static int
 fm801_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void fm801_audio_trigger (int dev, int state);
@@ -481,12 +481,12 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
   if (devc->open_mode & mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
   devc->open_mode |= mode;
   portc->open_mode = mode;
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/geode/geode.c oss-v4.1test0-070624-src-gpl/kernel/drv/geode/geode.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/geode/geode.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/geode/geode.c	Tue Jun 26 22:19:38 2007
@@ -350,7 +350,7 @@
 static int
 geode_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void geode_audio_trigger (int dev, int state);
@@ -386,13 +386,13 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   if (devc->open_mode & mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   devc->open_mode |= mode;
